"use strict";
var model_1 = require("../domain/model");
// todo: make this a function akin to string.format... describeAs('... #field', obj)
var ActivityDescription = (function () {
    function ActivityDescription(template) {
        var _this = this;
        this.template = template;
        this.arg_token = /{(\d+)}/g;
        this.field_token = /#(\w+)/g;
        this.interpolatedWithArguments = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return _this.template.replace(_this.arg_token, _this.using(args));
        };
        this.interpolatedWithFieldsOf = function (source) { return _this.template.replace(_this.field_token, _this.using(source)); };
        this.toString = function () { return _this.template; };
    }
    // todo: remove
    ActivityDescription.prototype.interpolateWith = function (activity, argumentsOfThePerformAsMethod) {
        var name = this.determineName(this.template, activity, argumentsOfThePerformAsMethod);
        return new model_1.RecordedActivity(name);
    };
    ActivityDescription.prototype.using = function (source) {
        return function (token, field) {
            switch ({}.toString.call(source[field])) {
                case '[object Function]': return source[field]();
                case '[object Array]': return source[field].join(', ');
                case '[object Object]': return source[field].toString();
                case '[object Undefined]': return token;
                default: return source[field];
            }
        };
    };
    // todo: remove
    ActivityDescription.prototype.determineName = function (template, activity, args) {
        return template.
            replace(this.field_token, this.using(activity)).
            replace(this.arg_token, this.using(args));
    };
    return ActivityDescription;
}());
exports.ActivityDescription = ActivityDescription;
//# sourceMappingURL=activity_description.js.map